/* A Bison parser, made by GNU Bison 1.875.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     NUMBER = 258,
     CHAR_CONST = 259,
     FLOAT = 260,
     STRING = 261,
     T_PCB = 262,
     T_LAYER = 263,
     T_VIA = 264,
     T_RAT = 265,
     T_LINE = 266,
     T_ARC = 267,
     T_RECTANGLE = 268,
     T_TEXT = 269,
     T_ELEMENTLINE = 270,
     T_ELEMENT = 271,
     T_PIN = 272,
     T_PAD = 273,
     T_GRID = 274,
     T_FLAGS = 275,
     T_SYMBOL = 276,
     T_SYMBOLLINE = 277,
     T_CURSOR = 278,
     T_ELEMENTARC = 279,
     T_MARK = 280,
     T_GROUPS = 281,
     T_STYLES = 282,
     T_POLYGON = 283,
     T_NETLIST = 284,
     T_NET = 285,
     T_CONN = 286,
     T_THERMAL = 287
   };
#endif
#define NUMBER 258
#define CHAR_CONST 259
#define FLOAT 260
#define STRING 261
#define T_PCB 262
#define T_LAYER 263
#define T_VIA 264
#define T_RAT 265
#define T_LINE 266
#define T_ARC 267
#define T_RECTANGLE 268
#define T_TEXT 269
#define T_ELEMENTLINE 270
#define T_ELEMENT 271
#define T_PIN 272
#define T_PAD 273
#define T_GRID 274
#define T_FLAGS 275
#define T_SYMBOL 276
#define T_SYMBOLLINE 277
#define T_CURSOR 278
#define T_ELEMENTARC 279
#define T_MARK 280
#define T_GROUPS 281
#define T_STYLES 282
#define T_POLYGON 283
#define T_NETLIST 284
#define T_NET 285
#define T_CONN 286
#define T_THERMAL 287




/* Copy the first part of user declarations.  */
#line 1 "parse_y.y"

/*
 *                            COPYRIGHT
 *
 *  PCB, interactive printed circuit board design
 *  Copyright (C) 1994,1995,1996 Thomas Nau
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Contact addresses for paper mail and Email:
 *  Thomas Nau, Schlehenweg 15, 88471 Baustetten, Germany
 *  Thomas.Nau@rz.uni-ulm.de
 *
 */

static	char	*rcsid = "$Id: parse_y.y,v 1.7 2004/02/15 07:12:45 danmc Exp $";

/* grammar to parse ASCII input of PCB description
 */

#include "global.h"
#include "create.h"
#include "data.h"
#include "error.h"
#include "mymem.h"
#include "misc.h"
#include "parse_l.h"
#include "remove.h"

#ifdef DMALLOC
# include <dmalloc.h> /* see http://dmalloc.com */
#endif

static	LayerTypePtr	Layer;
static	PolygonTypePtr	Polygon;
static	SymbolTypePtr	Symbol;
static	int		pin_num;
static	LibraryMenuTypePtr	Menu;
static	Boolean			LayerFlag[MAX_LAYER + 2];

extern	char			*yytext;		/* defined by LEX */
extern	PCBTypePtr		yyPCB;
extern	DataTypePtr		yyData;
extern	ElementTypePtr	yyElement;
extern	FontTypePtr		yyFont;
extern	int				yylineno;		/* linenumber */
extern	char			*yyfilename;	/* in this file */



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 64 "parse_y.y"
typedef union YYSTYPE {
	int		number;
	float		floating;
	char		*string;
} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 207 "parse_y.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 219 "parse_y.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  9
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   547

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  37
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  90
/* YYNRULES -- Number of rules. */
#define YYNRULES  168
/* YYNRULES -- Number of states. */
#define YYNSTATES  561

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   287

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      33,    34,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    35,     2,    36,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short yyprhs[] =
{
       0,     0,     3,     5,     7,     9,    11,    12,    24,    25,
      28,    30,    31,    32,    35,    40,    47,    54,    56,    58,
      60,    62,    69,    77,    85,    93,   100,   107,   114,   115,
     116,   121,   126,   127,   132,   133,   138,   143,   144,   145,
     147,   148,   150,   153,   155,   157,   159,   160,   163,   165,
     167,   169,   171,   173,   175,   187,   199,   210,   220,   229,
     240,   251,   252,   262,   264,   265,   267,   270,   272,   274,
     276,   278,   280,   282,   291,   293,   295,   297,   298,   307,
     318,   329,   339,   352,   365,   377,   386,   396,   406,   408,
     411,   416,   421,   422,   424,   426,   428,   430,   432,   433,
     446,   447,   463,   464,   481,   482,   501,   502,   521,   523,
     526,   528,   530,   532,   534,   536,   545,   554,   565,   576,
     582,   588,   590,   593,   595,   597,   599,   601,   610,   619,
     630,   641,   654,   667,   678,   688,   697,   711,   725,   737,
     748,   750,   753,   754,   764,   765,   775,   777,   779,   781,
     784,   786,   788,   789,   798,   807,   809,   810,   817,   819,
     820,   822,   825,   826,   836,   838,   839,   841,   844
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      38,     0,    -1,    39,    -1,    41,    -1,    44,    -1,     1,
      -1,    -1,    40,    46,    47,    52,    53,    54,    55,    56,
      43,    57,   118,    -1,    -1,    42,    57,    -1,    44,    -1,
      -1,    -1,    45,   109,    -1,     7,    33,     6,    34,    -1,
       7,    33,     6,     3,     3,    34,    -1,     7,    35,     6,
       3,     3,    36,    -1,    48,    -1,    49,    -1,    50,    -1,
      51,    -1,    19,    33,     3,     3,     3,    34,    -1,    19,
      33,     3,     3,     3,     3,    34,    -1,    19,    33,     5,
       3,     3,     3,    34,    -1,    19,    35,     5,     3,     3,
       3,    36,    -1,    23,    33,     3,     3,     3,    34,    -1,
      23,    35,     3,     3,     3,    36,    -1,    23,    35,     3,
       3,     5,    36,    -1,    -1,    -1,    32,    35,     5,    36,
      -1,    20,    33,     3,    34,    -1,    -1,    26,    33,     6,
      34,    -1,    -1,    27,    33,     6,    34,    -1,    27,    35,
       6,    36,    -1,    -1,    -1,    58,    -1,    -1,    59,    -1,
      58,    59,    -1,    61,    -1,    67,    -1,    68,    -1,    -1,
      60,    85,    -1,     1,    -1,    62,    -1,    63,    -1,    64,
      -1,    65,    -1,    66,    -1,     9,    35,     3,     3,     3,
       3,     3,     3,     6,     3,    36,    -1,     9,    33,     3,
       3,     3,     3,     3,     3,     6,     3,    34,    -1,     9,
      33,     3,     3,     3,     3,     3,     6,     3,    34,    -1,
       9,    33,     3,     3,     3,     3,     6,     3,    34,    -1,
       9,    33,     3,     3,     3,     6,     3,    34,    -1,    10,
      35,     3,     3,     3,     3,     3,     3,     3,    36,    -1,
      10,    33,     3,     3,     3,     3,     3,     3,     3,    34,
      -1,    -1,     8,    33,     3,     6,    34,    33,    69,    70,
      34,    -1,    71,    -1,    -1,    72,    -1,    71,    72,    -1,
      74,    -1,    75,    -1,    76,    -1,    77,    -1,    78,    -1,
      79,    -1,    13,    33,     3,     3,     3,     3,     3,    34,
      -1,    82,    -1,    81,    -1,    80,    -1,    -1,    28,    33,
       3,    34,    33,    73,    83,    34,    -1,    11,    35,     3,
       3,     3,     3,     3,     3,     3,    36,    -1,    11,    33,
       3,     3,     3,     3,     3,     3,     3,    34,    -1,    11,
      33,     3,     3,     3,     3,     3,     3,    34,    -1,    12,
      35,     3,     3,     3,     3,     3,     3,     3,     3,     3,
      36,    -1,    12,    33,     3,     3,     3,     3,     3,     3,
       3,     3,     3,    34,    -1,    12,    33,     3,     3,     3,
       3,     3,     3,     3,     3,    34,    -1,    14,    33,     3,
       3,     3,     6,     3,    34,    -1,    14,    33,     3,     3,
       3,     3,     6,     3,    34,    -1,    14,    35,     3,     3,
       3,     3,     6,     3,    36,    -1,    84,    -1,    83,    84,
      -1,    33,     3,     3,    34,    -1,    35,     3,     3,    36,
      -1,    -1,    86,    -1,    88,    -1,    90,    -1,    92,    -1,
      94,    -1,    -1,    16,    33,     6,     6,     3,     3,     3,
      34,    33,    87,    96,    34,    -1,    -1,    16,    33,     3,
       6,     6,     3,     3,     3,     3,     3,    34,    33,    89,
      96,    34,    -1,    -1,    16,    33,     3,     6,     6,     6,
       3,     3,     3,     3,     3,    34,    33,    91,    96,    34,
      -1,    -1,    16,    33,     3,     6,     6,     6,     3,     3,
       3,     3,     3,     3,     3,    34,    33,    93,    98,    34,
      -1,    -1,    16,    35,     3,     6,     6,     6,     3,     3,
       3,     3,     3,     3,     3,    36,    33,    95,    98,    34,
      -1,    97,    -1,    96,    97,    -1,   102,    -1,   103,    -1,
     104,    -1,   107,    -1,   108,    -1,    15,    35,     3,     3,
       3,     3,     3,    36,    -1,    15,    33,     3,     3,     3,
       3,     3,    34,    -1,    24,    35,     3,     3,     3,     3,
       3,     3,     3,    36,    -1,    24,    33,     3,     3,     3,
       3,     3,     3,     3,    34,    -1,    25,    35,     3,     3,
      36,    -1,    25,    33,     3,     3,    34,    -1,    99,    -1,
      98,    99,    -1,   101,    -1,   100,    -1,   106,    -1,   105,
      -1,    15,    35,     3,     3,     3,     3,     3,    36,    -1,
      15,    33,     3,     3,     3,     3,     3,    34,    -1,    24,
      35,     3,     3,     3,     3,     3,     3,     3,    36,    -1,
      24,    33,     3,     3,     3,     3,     3,     3,     3,    34,
      -1,    17,    35,     3,     3,     3,     3,     3,     3,     6,
       6,     3,    36,    -1,    17,    33,     3,     3,     3,     3,
       3,     3,     6,     6,     3,    34,    -1,    17,    33,     3,
       3,     3,     3,     6,     6,     3,    34,    -1,    17,    33,
       3,     3,     3,     3,     6,     3,    34,    -1,    17,    33,
       3,     3,     3,     6,     3,    34,    -1,    18,    35,     3,
       3,     3,     3,     3,     3,     3,     6,     6,     3,    36,
      -1,    18,    33,     3,     3,     3,     3,     3,     3,     3,
       6,     6,     3,    34,    -1,    18,    33,     3,     3,     3,
       3,     3,     6,     6,     3,    34,    -1,    18,    33,     3,
       3,     3,     3,     3,     6,     3,    34,    -1,   110,    -1,
     109,   110,    -1,    -1,    21,    35,   113,     3,    36,    33,
     111,   114,    34,    -1,    -1,    21,    33,   113,     3,    34,
      33,   112,   114,    34,    -1,     3,    -1,     4,    -1,   115,
      -1,   114,   115,    -1,   116,    -1,   117,    -1,    -1,    22,
      33,     3,     3,     3,     3,     3,    34,    -1,    22,    35,
       3,     3,     3,     3,     3,    36,    -1,   119,    -1,    -1,
      29,    33,    34,    33,   120,    34,    -1,   121,    -1,    -1,
     122,    -1,   121,   122,    -1,    -1,    30,    33,     6,     6,
      34,    33,   123,   124,    34,    -1,   125,    -1,    -1,   126,
      -1,   125,   126,    -1,    31,    33,     6,    34,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,    84,    84,    85,    86,    87,    91,    91,   120,   120,
     138,   139,   144,   144,   165,   171,   177,   186,   187,   188,
     189,   192,   200,   213,   225,   238,   244,   250,   256,   259,
     261,   268,   272,   276,   284,   287,   295,   303,   304,   308,
     309,   313,   314,   318,   319,   320,   322,   322,   329,   333,
     334,   335,   336,   337,   342,   352,   363,   373,   383,   399,
     404,   414,   413,   435,   436,   440,   441,   445,   446,   447,
     448,   449,   450,   452,   457,   458,   459,   462,   461,   483,
     491,   499,   510,   518,   526,   535,   545,   561,   577,   578,
     583,   587,   591,   595,   596,   597,   598,   599,   607,   606,
     625,   624,   643,   642,   663,   661,   684,   682,   700,   701,
     705,   706,   707,   708,   709,   711,   716,   721,   725,   730,
     735,   743,   744,   748,   749,   750,   751,   753,   759,   766,
     771,   781,   793,   805,   817,   833,   853,   866,   879,   890,
     903,   904,   909,   908,   926,   925,   945,   946,   950,   951,
     955,   956,   957,   962,   969,   975,   976,   980,   985,   986,
     990,   991,   997,   996,  1006,  1007,  1011,  1012,  1016
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "NUMBER", "CHAR_CONST", "FLOAT", "STRING", 
  "T_PCB", "T_LAYER", "T_VIA", "T_RAT", "T_LINE", "T_ARC", "T_RECTANGLE", 
  "T_TEXT", "T_ELEMENTLINE", "T_ELEMENT", "T_PIN", "T_PAD", "T_GRID", 
  "T_FLAGS", "T_SYMBOL", "T_SYMBOLLINE", "T_CURSOR", "T_ELEMENTARC", 
  "T_MARK", "T_GROUPS", "T_STYLES", "T_POLYGON", "T_NETLIST", "T_NET", 
  "T_CONN", "T_THERMAL", "'('", "')'", "'['", "']'", "$accept", "parse", 
  "parsepcb", "@1", "parsedata", "@2", "pcbfont", "parsefont", "@3", 
  "pcbname", "pcbgrid", "pcbgridold", "pcbgridnew", "pcb2grid", 
  "pcbhigrid", "pcbcursor", "pcbthermal", "pcbflags", "pcbgroups", 
  "pcbstyles", "pcbdata", "pcbdefinitions", "pcbdefinition", "@4", "via", 
  "via_hi_format", "via_2.0_format", "via_1.7_format", "via_newformat", 
  "via_oldformat", "rats", "layer", "@5", "layerdata", "layerdefinitions", 
  "layerdefinition", "@6", "line_hi_format", "line_1.7_format", 
  "line_oldformat", "arc_hi_format", "arc_1.7_format", "arc_oldformat", 
  "text_oldformat", "text_newformat", "text_hi_format", "polygonpoints", 
  "polygonpoint", "element", "element_oldformat", "@7", 
  "element_1.3.4_format", "@8", "element_newformat", "@9", 
  "element_1.7_format", "@10", "element_hi_format", "@11", 
  "elementdefinitions", "elementdefinition", "relementdefs", 
  "relementdef", "pin_hi_format", "pin_1.7_format", "pin_1.6.3_format", 
  "pin_newformat", "pin_oldformat", "pad_hi_format", "pad_1.7_format", 
  "pad_newformat", "pad", "symbols", "symbol", "@12", "@13", "symbolid", 
  "symboldata", "symboldefinitions", "symboldefinition", "hiressymbol", 
  "pcbnetlist", "pcbnetdef", "nets", "netdefs", "net", "@14", 
  "connections", "conndefs", "conn", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,    40,    41,    91,    93
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    37,    38,    38,    38,    38,    40,    39,    42,    41,
      43,    43,    45,    44,    46,    46,    46,    47,    47,    47,
      47,    48,    49,    50,    51,    52,    52,    52,    52,    53,
      53,    54,    54,    55,    55,    56,    56,    56,    56,    57,
      57,    58,    58,    59,    59,    59,    60,    59,    59,    61,
      61,    61,    61,    61,    62,    63,    64,    65,    66,    67,
      67,    69,    68,    70,    70,    71,    71,    72,    72,    72,
      72,    72,    72,    72,    72,    72,    72,    73,    72,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    83,
      84,    84,    84,    85,    85,    85,    85,    85,    87,    86,
      89,    88,    91,    90,    93,    92,    95,    94,    96,    96,
      97,    97,    97,    97,    97,    97,    97,    97,    97,    97,
      97,    98,    98,    99,    99,    99,    99,    99,    99,    99,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   109,   111,   110,   112,   110,   113,   113,   114,   114,
     115,   115,   115,   116,   117,   118,   118,   119,   120,   120,
     121,   121,   123,   122,   124,   124,   125,   125,   126
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     1,     1,     1,     1,     0,    11,     0,     2,
       1,     0,     0,     2,     4,     6,     6,     1,     1,     1,
       1,     6,     7,     7,     7,     6,     6,     6,     0,     0,
       4,     4,     0,     4,     0,     4,     4,     0,     0,     1,
       0,     1,     2,     1,     1,     1,     0,     2,     1,     1,
       1,     1,     1,     1,    11,    11,    10,     9,     8,    10,
      10,     0,     9,     1,     0,     1,     2,     1,     1,     1,
       1,     1,     1,     8,     1,     1,     1,     0,     8,    10,
      10,     9,    12,    12,    11,     8,     9,     9,     1,     2,
       4,     4,     0,     1,     1,     1,     1,     1,     0,    12,
       0,    15,     0,    16,     0,    18,     0,    18,     1,     2,
       1,     1,     1,     1,     1,     8,     8,    10,    10,     5,
       5,     1,     2,     1,     1,     1,     1,     8,     8,    10,
      10,    12,    12,    10,     9,     8,    13,    13,    11,    10,
       1,     2,     0,     9,     0,     9,     1,     1,     1,     2,
       1,     1,     0,     8,     8,     1,     0,     6,     1,     0,
       1,     2,     0,     9,     1,     0,     1,     2,     4
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       0,     5,     0,     2,     0,     3,     0,     4,     0,     1,
       0,     0,    48,     0,     0,     0,     9,     0,    41,     0,
      43,    49,    50,    51,    52,    53,    44,    45,     0,    13,
     140,     0,     0,     0,    28,    17,    18,    19,    20,     0,
       0,     0,     0,     0,    42,     0,    47,    93,    94,    95,
      96,    97,     0,     0,   141,     0,     0,     0,     0,     0,
      29,     0,     0,     0,     0,     0,     0,     0,   146,   147,
       0,     0,     0,    14,     0,     0,     0,     0,     0,     0,
       0,    32,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    34,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    15,    16,     0,     0,     0,     0,     0,     0,
       0,     0,    37,    61,     0,     0,     0,     0,     0,     0,
       0,     0,   144,   142,     0,    21,     0,     0,     0,     0,
       0,    30,     0,     0,     0,    11,    64,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   152,   152,    22,
      23,    24,    25,    26,    27,    31,     0,     0,     0,     0,
      10,     0,     0,     0,     0,     0,     0,    63,    65,    67,
      68,    69,    70,    71,    72,    76,    75,    74,     0,     0,
       0,    58,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   148,   150,   151,     0,    33,     0,     0,   156,     0,
       0,     0,     0,     0,     0,     0,     0,    62,    66,     0,
       0,    57,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   145,   149,   143,    35,    36,     0,     7,   155,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    56,     0,
      60,    59,     0,     0,    98,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    55,    54,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    77,     0,     0,     0,     0,     0,     0,
       0,     0,   108,   110,   111,   112,   113,   114,     0,     0,
       0,   159,     0,     0,     0,     0,     0,     0,     0,     0,
      92,   100,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    99,   109,     0,     0,     0,     0,     0,   158,
     160,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    88,     0,     0,   102,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   157,   161,
       0,     0,     0,     0,    73,     0,    85,     0,     0,     0,
      78,    89,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   153,   154,     0,     0,    81,     0,
       0,     0,    86,    87,     0,     0,   101,   104,     0,     0,
       0,     0,     0,     0,     0,   120,   119,   106,     0,    80,
      79,     0,     0,    90,    91,     0,   103,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    84,     0,     0,
       0,     0,     0,     0,   121,   124,   123,   126,   125,     0,
       0,     0,     0,     0,     0,     0,     0,   162,    83,    82,
       0,     0,     0,     0,     0,     0,     0,     0,   105,   122,
     116,   115,     0,     0,   135,     0,     0,     0,   107,   165,
       0,     0,     0,     0,     0,     0,     0,     0,   134,     0,
       0,     0,     0,     0,     0,     0,   164,   166,     0,     0,
       0,     0,     0,     0,     0,     0,   133,   139,     0,   118,
     117,     0,   163,   167,     0,     0,     0,     0,     0,     0,
       0,     0,   138,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   168,     0,     0,     0,     0,     0,     0,     0,
       0,   128,   127,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   130,
     129,     0,     0,     0,     0,   132,   131,     0,     0,   137,
     136
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short yydefgoto[] =
{
      -1,     2,     3,     4,     5,     6,   169,     7,     8,    11,
      34,    35,    36,    37,    38,    60,    81,   101,   122,   145,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,   146,   176,   177,   178,   310,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   341,   342,    46,    47,
     271,    48,   343,    49,   374,    50,   415,    51,   424,   291,
     292,   433,   434,   435,   436,   293,   294,   295,   437,   438,
     296,   297,    29,    30,   158,   157,    70,   200,   201,   202,
     203,   237,   238,   328,   329,   330,   469,   485,   486,   487
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -423
static const short yypact[] =
{
      39,  -423,    16,  -423,    36,  -423,    88,  -423,    32,  -423,
      29,    38,  -423,   -10,    99,   102,  -423,     9,  -423,    47,
    -423,  -423,  -423,  -423,  -423,  -423,  -423,  -423,   103,    32,
    -423,    62,    66,   106,    55,  -423,  -423,  -423,  -423,    76,
      80,    84,   152,   153,  -423,   107,  -423,  -423,  -423,  -423,
    -423,  -423,     4,     4,  -423,    -2,   170,   140,    95,   111,
      73,   172,   176,   177,   178,   179,    96,   180,  -423,  -423,
     181,   182,   183,  -423,   184,   185,   186,   187,   188,   189,
     158,   174,   161,   193,   194,   195,   196,   197,   198,   199,
     166,   165,   168,   171,   203,   205,   206,   207,   208,   126,
     190,   191,   192,   100,   209,   210,   211,   212,   213,   214,
     200,   201,  -423,  -423,    -1,   216,   218,   219,   144,   202,
     221,   204,   215,  -423,   110,   223,   224,   225,   226,   116,
     227,   229,  -423,  -423,   217,  -423,   220,   222,   228,   230,
     231,  -423,   234,   233,   115,   232,    81,   117,   237,   235,
     238,   240,   241,   242,   243,   244,   245,   239,   239,  -423,
    -423,  -423,  -423,  -423,  -423,  -423,   236,   246,   249,    12,
    -423,   118,   119,   247,   124,   248,   250,    81,  -423,  -423,
    -423,  -423,  -423,  -423,  -423,  -423,  -423,  -423,   251,   253,
     252,  -423,   254,   256,   260,   261,   262,   255,   268,   125,
      -8,  -423,  -423,  -423,    -7,  -423,   257,   258,   259,   269,
     270,   271,   272,   273,   274,   275,   276,  -423,  -423,   279,
     263,  -423,   280,   264,   265,   282,   284,   266,   287,   289,
     290,  -423,  -423,  -423,  -423,  -423,   267,  -423,  -423,   292,
     293,   299,   300,   301,   302,   303,   277,   278,  -423,   281,
    -423,  -423,   304,   305,  -423,   306,   307,   310,   285,   311,
     312,   313,   315,   317,   318,   319,   291,  -423,  -423,   294,
     320,    93,   322,   323,   324,   296,   327,   328,   329,   330,
     331,   121,   332,  -423,   308,     0,   128,   309,   314,   129,
     132,    27,  -423,  -423,  -423,  -423,  -423,  -423,   333,   334,
     335,   316,   336,   337,   340,   341,   342,   343,   345,   344,
     133,  -423,   348,   321,   349,   350,   352,   353,   354,   355,
     356,   357,  -423,  -423,   358,   359,   360,   338,   339,   316,
    -423,   361,   362,   363,   364,   346,   365,   347,   366,   367,
     369,    -4,  -423,    93,   351,  -423,   371,   372,   373,   374,
     375,   376,   379,   380,   368,   377,   370,   378,  -423,  -423,
       1,   383,   384,   385,  -423,   381,  -423,   382,   386,   387,
    -423,  -423,    41,   388,    93,   389,   390,   391,   392,   393,
     394,   395,   396,   397,  -423,  -423,   399,   400,  -423,   401,
     398,   404,  -423,  -423,   402,   403,  -423,  -423,    52,   405,
     406,   122,   407,   409,   410,  -423,  -423,  -423,   408,  -423,
    -423,     2,   411,  -423,  -423,    97,  -423,   413,   414,   416,
     417,   420,   421,   422,    97,   412,   415,  -423,   418,   136,
     137,   141,   142,    56,  -423,  -423,  -423,  -423,  -423,   419,
     423,   123,   424,   425,   430,   432,    67,  -423,  -423,  -423,
     435,   437,   438,   440,   441,   443,   444,   445,  -423,  -423,
    -423,  -423,   426,   447,  -423,   127,   448,   449,  -423,   431,
     452,   453,   454,   458,   460,   461,   462,   463,  -423,   433,
     434,   466,   436,   439,   446,   442,   431,  -423,   468,   469,
     470,   471,   474,   475,   477,   478,  -423,  -423,   450,  -423,
    -423,   476,  -423,  -423,   480,   482,   483,   484,   485,   486,
     487,   488,  -423,   459,   489,   491,   492,   493,   494,   495,
     496,   497,  -423,   467,   472,   499,   500,   501,   502,   503,
     504,  -423,  -423,   505,   506,   507,   510,   511,   512,   513,
     514,   515,   516,   490,   473,   520,   522,   521,   523,  -423,
    -423,   498,   481,   525,   527,  -423,  -423,   508,   509,  -423,
    -423
};

/* YYPGOTO[NTERM-NUM].  */
static const short yypgoto[] =
{
    -423,  -423,  -423,  -423,  -423,  -423,  -423,    70,  -423,  -423,
    -423,  -423,  -423,  -423,  -423,  -423,  -423,  -423,  -423,  -423,
      63,  -423,   517,  -423,  -423,  -423,  -423,  -423,  -423,  -423,
    -423,  -423,  -423,  -423,  -423,    54,  -423,  -423,  -423,  -423,
    -423,  -423,  -423,  -423,  -423,  -423,  -423,  -105,  -423,  -423,
    -423,  -423,  -423,  -423,  -423,  -423,  -423,  -423,  -423,  -337,
    -291,  -175,  -422,  -423,  -423,  -423,  -423,  -423,  -423,  -423,
    -423,  -423,  -423,   518,  -423,  -423,   465,    92,  -150,  -423,
    -423,  -423,  -423,  -423,  -423,    69,  -423,  -423,  -423,   -95
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -47
static const short yytable[] =
{
     323,    72,   134,   312,   387,   426,   372,    68,    69,   -39,
      12,   459,   -40,    12,   199,   199,     9,    13,    14,    15,
      13,    14,    15,    39,   459,   -46,   231,   233,   -46,   339,
     370,   340,    73,   135,   313,   388,   427,   398,   -39,    -8,
       1,   -40,   286,    10,   287,   288,    -6,    -8,    -8,    -8,
     232,   289,   290,    28,   232,    -8,   286,    33,   287,   288,
     -12,   322,    31,    45,    32,   289,   290,   286,    55,   287,
     288,   429,    56,   430,   431,   396,   289,   290,    59,    61,
     432,   323,   429,    62,   430,   431,   416,    63,   -40,    12,
     458,   432,   171,   172,   173,   174,    13,    14,    15,    87,
      77,   468,    88,   124,   -46,    80,   125,   323,   286,   175,
     287,   288,   429,   147,   430,   431,   148,   289,   290,   153,
     188,   432,   154,   189,   307,   419,   462,   308,   420,   463,
     480,   119,    40,   481,    41,    42,    52,    43,    53,    57,
      66,    58,    67,    75,    78,    76,    79,   139,   167,   140,
     168,   209,   211,   210,   212,    64,    65,   214,   229,   215,
     230,   314,   318,   315,   319,   320,   339,   321,   340,   450,
     452,   451,   453,    74,   454,   456,   455,   457,    82,    83,
      84,    85,    86,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   102,   103,   104,   105,   106,
     110,   111,   112,   107,   108,   109,   114,   113,   115,   116,
     117,   118,   126,   127,   128,   170,   130,   121,   129,   136,
     131,   137,   138,   120,   142,   123,   149,   150,   151,   152,
     155,   218,   208,   132,   133,   156,   371,   143,   141,   166,
     190,   192,   144,   193,   194,   195,   196,   197,   198,   446,
     204,   159,   206,   -12,   160,   207,   220,   219,   161,   223,
     222,   199,   162,   224,   225,   226,   163,   164,   165,   191,
     205,   228,   239,   240,   241,   242,   243,   244,   245,   246,
     213,   216,   247,   249,   217,   252,   221,   253,   236,   227,
     255,   234,   256,   257,   235,   259,   260,   248,   250,   254,
     258,   251,   261,   262,   263,   264,   265,   269,   270,   272,
     273,   266,   267,   274,   276,   277,   278,   268,   279,   275,
     280,   281,   282,   285,   283,   298,   299,   300,   284,   301,
     302,   303,   304,   305,   306,   309,   324,   325,   326,   331,
     332,   311,   316,   333,   334,   335,   327,   317,   337,   336,
     338,   344,   346,   347,   345,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   360,   361,   362,   363,   365,   367,
     368,   357,   369,   358,   375,   376,   377,   378,   379,   380,
     364,   366,   381,   382,   386,   373,   389,   390,   391,   394,
     395,   503,   399,   400,   401,   402,   403,   404,   359,     0,
       0,   411,     0,     0,   383,   408,   385,   412,   417,   418,
     421,   384,   422,   423,   428,   392,   439,   440,   393,     0,
     442,   397,   441,   443,   444,   445,     0,     0,     0,   405,
     407,   465,   406,   466,   409,   467,   413,   410,   470,   414,
     471,   472,   425,   473,   474,   447,   475,   476,   477,   448,
     479,   482,   483,   460,   449,   488,   489,   490,   464,   461,
     478,   491,   484,   492,   493,   494,   495,   496,   497,   498,
     499,   504,   505,   506,   507,   500,   502,   508,   509,   501,
     510,   511,   513,   514,   512,   515,   516,   517,   518,   519,
     520,   521,   523,   522,   524,   525,   526,   527,   528,   529,
     530,   531,   533,   534,   535,   536,   537,   538,   532,   550,
     541,   539,   540,   542,   543,   544,     0,   556,    71,   545,
     546,   547,   548,   551,   549,   552,     0,   553,   557,   554,
     558,     0,   555,     0,    44,     0,     0,     0,     0,     0,
       0,     0,   559,     0,     0,   560,     0,    54
};

static const short yycheck[] =
{
     291,     3,     3,     3,     3,     3,   343,     3,     4,     0,
       1,   433,     0,     1,    22,    22,     0,     8,     9,    10,
       8,     9,    10,    33,   446,    16,    34,    34,    16,    33,
      34,    35,    34,    34,    34,    34,    34,   374,    29,     0,
       1,    29,    15,     7,    17,    18,     7,     8,     9,    10,
     200,    24,    25,    21,   204,    16,    15,    19,    17,    18,
      21,    34,    33,    16,    35,    24,    25,    15,     6,    17,
      18,    15,     6,    17,    18,    34,    24,    25,    23,     3,
      24,   372,    15,     3,    17,    18,    34,     3,     0,     1,
      34,    24,    11,    12,    13,    14,     8,     9,    10,     3,
       5,    34,     6,     3,    16,    32,     6,   398,    15,    28,
      17,    18,    15,     3,    17,    18,     6,    24,    25,     3,
       3,    24,     6,     6,     3,     3,     3,     6,     6,     6,
       3,     5,    33,     6,    35,    33,    33,    35,    35,    33,
      33,    35,    35,     3,    33,     5,    35,     3,    33,     5,
      35,    33,    33,    35,    35,     3,     3,    33,    33,    35,
      35,    33,    33,    35,    35,    33,    33,    35,    35,    33,
      33,    35,    35,     3,    33,    33,    35,    35,     6,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,    35,    20,    34,     3,     3,     3,     3,
      34,    36,    34,     6,     6,     6,     3,    36,     3,     3,
       3,     3,     3,     3,     3,   145,     3,    26,     6,     3,
       6,     3,     3,    33,     3,    33,     3,     3,     3,     3,
       3,   177,   169,    33,    33,     6,   341,    33,    36,     6,
       3,     3,    27,     3,     3,     3,     3,     3,     3,   424,
     158,    34,     6,    21,    34,     6,     3,     6,    36,     3,
       6,    22,    34,     3,     3,     3,    36,    36,    34,    34,
      34,     3,     3,     3,     3,     3,     3,     3,     3,     3,
      33,    33,     3,     3,    34,     3,    34,     3,    29,    34,
       3,    34,     3,     3,    36,     3,     3,    34,    34,    33,
      33,    36,     3,     3,     3,     3,     3,     3,     3,     3,
       3,    34,    34,     3,     3,     3,     3,    36,     3,    34,
       3,     3,     3,     3,    33,     3,     3,     3,    34,    33,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,    33,    33,     3,     3,     3,    30,    33,     3,     6,
       6,     3,     3,     3,    33,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,    33,     3,    34,     3,     3,     3,     3,     3,     3,
      34,    34,     3,     3,     6,    34,     3,     3,     3,     3,
       3,   486,     3,     3,     3,     3,     3,     3,   329,    -1,
      -1,     3,    -1,    -1,    36,     6,    36,     3,     3,     3,
       3,    34,     3,     3,     3,    34,     3,     3,    36,    -1,
       3,    33,     6,     3,     3,     3,    -1,    -1,    -1,    34,
      33,     6,    36,     3,    34,     3,    34,    36,     3,    36,
       3,     3,    34,     3,     3,    33,     3,     3,     3,    34,
       3,     3,     3,    34,    36,     3,     3,     3,    34,    36,
      34,     3,    31,     3,     3,     3,     3,    34,    34,     3,
      34,     3,     3,     3,     3,    36,    34,     3,     3,    33,
       3,     3,     6,     3,    34,     3,     3,     3,     3,     3,
       3,     3,     3,    34,     3,     3,     3,     3,     3,     3,
       3,    34,     3,     3,     3,     3,     3,     3,    36,    36,
       3,     6,     6,     3,     3,     3,    -1,    36,    53,     6,
       6,     6,     6,     3,    34,     3,    -1,     6,     3,     6,
       3,    -1,    34,    -1,    17,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    34,    -1,    -1,    36,    -1,    29
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,     1,    38,    39,    40,    41,    42,    44,    45,     0,
       7,    46,     1,     8,     9,    10,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    21,   109,
     110,    33,    35,    19,    47,    48,    49,    50,    51,    33,
      33,    35,    33,    35,    59,    16,    85,    86,    88,    90,
      92,    94,    33,    35,   110,     6,     6,    33,    35,    23,
      52,     3,     3,     3,     3,     3,    33,    35,     3,     4,
     113,   113,     3,    34,     3,     3,     5,     5,    33,    35,
      32,    53,     6,     3,     3,     3,     3,     3,     6,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,    35,
      20,    54,    34,     3,     3,     3,     3,     6,     6,     6,
      34,    36,    34,    36,     3,     3,     3,     3,     3,     5,
      33,    26,    55,    33,     3,     6,     3,     3,     3,     6,
       3,     6,    33,    33,     3,    34,     3,     3,     3,     3,
       5,    36,     3,    33,    27,    56,    69,     3,     6,     3,
       3,     3,     3,     3,     6,     3,     6,   112,   111,    34,
      34,    36,    34,    36,    36,    34,     6,    33,    35,    43,
      44,    11,    12,    13,    14,    28,    70,    71,    72,    74,
      75,    76,    77,    78,    79,    80,    81,    82,     3,     6,
       3,    34,     3,     3,     3,     3,     3,     3,     3,    22,
     114,   115,   116,   117,   114,    34,     6,     6,    57,    33,
      35,    33,    35,    33,    33,    35,    33,    34,    72,     6,
       3,    34,     6,     3,     3,     3,     3,    34,     3,    33,
      35,    34,   115,    34,    34,    36,    29,   118,   119,     3,
       3,     3,     3,     3,     3,     3,     3,     3,    34,     3,
      34,    36,     3,     3,    33,     3,     3,     3,    33,     3,
       3,     3,     3,     3,     3,     3,    34,    34,    36,     3,
       3,    87,     3,     3,     3,    34,     3,     3,     3,     3,
       3,     3,     3,    33,    34,     3,    15,    17,    18,    24,
      25,    96,    97,   102,   103,   104,   107,   108,     3,     3,
       3,    33,     3,     3,     3,     3,     3,     3,     6,     3,
      73,    33,     3,    34,    33,    35,    33,    33,    33,    35,
      33,    35,    34,    97,     3,     3,     3,    30,   120,   121,
     122,     3,     3,     3,     3,     3,     6,     3,     6,    33,
      35,    83,    84,    89,     3,    33,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,    33,    34,   122,
       3,     3,     3,     3,    34,     3,    34,     3,     3,     3,
      34,    84,    96,    34,    91,     3,     3,     3,     3,     3,
       3,     3,     3,    36,    34,    36,     6,     3,    34,     3,
       3,     3,    34,    36,     3,     3,    34,    33,    96,     3,
       3,     3,     3,     3,     3,    34,    36,    33,     6,    34,
      36,     3,     3,    34,    36,    93,    34,     3,     3,     3,
       6,     3,     3,     3,    95,    34,     3,    34,     3,    15,
      17,    18,    24,    98,    99,   100,   101,   105,   106,     3,
       3,     6,     3,     3,     3,     3,    98,    33,    34,    36,
      33,    35,    33,    35,    33,    35,    33,    35,    34,    99,
      34,    36,     3,     6,    34,     6,     3,     3,    34,   123,
       3,     3,     3,     3,     3,     3,     3,     3,    34,     3,
       3,     6,     3,     3,    31,   124,   125,   126,     3,     3,
       3,     3,     3,     3,     3,     3,    34,    34,     3,    34,
      36,    33,    34,   126,     3,     3,     3,     3,     3,     3,
       3,     3,    34,     6,     3,     3,     3,     3,     3,     3,
       3,     3,    34,     3,     3,     3,     3,     3,     3,     3,
       3,    34,    36,     3,     3,     3,     3,     3,     3,     6,
       6,     3,     3,     3,     3,     6,     6,     6,     6,    34,
      36,     3,     3,     6,     6,    34,    36,     3,     3,    34,
      36
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrlab1

/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)         \
  Current.first_line   = Rhs[1].first_line;      \
  Current.first_column = Rhs[1].first_column;    \
  Current.last_line    = Rhs[N].last_line;       \
  Current.last_column  = Rhs[N].last_column;
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (cinluded).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylineno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylineno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 5:
#line 87 "parse_y.y"
    { YYABORT; }
    break;

  case 6:
#line 91 "parse_y.y"
    {
					/* reset flags for 'used layers';
					 * init font and data pointers
					 */
				int	i;

				if (!yyPCB)
				{
					Message("illegal fileformat\n");
					YYABORT;
				}
				for (i = 0; i < MAX_LAYER + 2; i++)
					LayerFlag[i] = False;
				yyFont = &yyPCB->Font;
				yyData = yyPCB->Data;
			}
    break;

  case 8:
#line 120 "parse_y.y"
    {
					/* reset flags for 'used layers';
					 * init font and data pointers
					 */
				int	i;

				if (!yyData || !yyFont)
				{
					Message("illegal fileformat\n");
					YYABORT;
				}
				for (i = 0; i < MAX_LAYER + 2; i++)
					LayerFlag[i] = False;
			}
    break;

  case 12:
#line 144 "parse_y.y"
    {
					/* mark all symbols invalid */
				int	i;

				if (!yyFont)
				{
					Message("illegal fileformat\n");
					YYABORT;
				}
				yyFont->Valid = False;
				for (i = 0; i <= MAX_FONTPOSITION; i++)
					yyFont->Symbol[i].Valid = False;
			}
    break;

  case 13:
#line 158 "parse_y.y"
    {
				yyFont->Valid = True;
		  		SetFontInfo(yyFont);
			}
    break;

  case 14:
#line 166 "parse_y.y"
    {
				yyPCB->Name = yyvsp[-1].string;
				yyPCB->MaxWidth = MAX_COORD;
				yyPCB->MaxHeight = MAX_COORD;
			}
    break;

  case 15:
#line 172 "parse_y.y"
    {
				yyPCB->Name = yyvsp[-3].string;
				yyPCB->MaxWidth = yyvsp[-2].number*100;
				yyPCB->MaxHeight = yyvsp[-1].number*100;
			}
    break;

  case 16:
#line 178 "parse_y.y"
    {
				yyPCB->Name = yyvsp[-3].string;
				yyPCB->MaxWidth = yyvsp[-2].number;
				yyPCB->MaxHeight = yyvsp[-1].number;
			}
    break;

  case 21:
#line 193 "parse_y.y"
    {
				yyPCB->Grid = yyvsp[-3].number*100;
				yyPCB->GridOffsetX = yyvsp[-2].number*100;
				yyPCB->GridOffsetY = yyvsp[-1].number*100;
			}
    break;

  case 22:
#line 201 "parse_y.y"
    {
				yyPCB->Grid = yyvsp[-4].number*100;
				yyPCB->GridOffsetX = yyvsp[-3].number*100;
				yyPCB->GridOffsetY = yyvsp[-2].number*100;
				if (yyvsp[-1].number)
					Settings.DrawGrid = True;
				else
					Settings.DrawGrid = False;
			}
    break;

  case 23:
#line 214 "parse_y.y"
    {
				yyPCB->Grid = yyvsp[-4].floating*100;
				yyPCB->GridOffsetX = yyvsp[-3].number*100;
				yyPCB->GridOffsetY = yyvsp[-2].number*100;
				if (yyvsp[-1].number)
					Settings.DrawGrid = True;
				else
					Settings.DrawGrid = False;
			}
    break;

  case 24:
#line 226 "parse_y.y"
    {
				yyPCB->Grid = yyvsp[-4].floating;
				yyPCB->GridOffsetX = yyvsp[-3].number;
				yyPCB->GridOffsetY = yyvsp[-2].number;
				if (yyvsp[-1].number)
					Settings.DrawGrid = True;
				else
					Settings.DrawGrid = False;
			}
    break;

  case 25:
#line 239 "parse_y.y"
    {
				yyPCB->CursorX = yyvsp[-3].number*100;
				yyPCB->CursorY = yyvsp[-2].number*100;
				yyPCB->Zoom = yyvsp[-1].number*2;
			}
    break;

  case 26:
#line 245 "parse_y.y"
    {
				yyPCB->CursorX = yyvsp[-3].number;
				yyPCB->CursorY = yyvsp[-2].number;
				yyPCB->Zoom = yyvsp[-1].number;
			}
    break;

  case 27:
#line 251 "parse_y.y"
    {
				yyPCB->CursorX = yyvsp[-3].number;
				yyPCB->CursorY = yyvsp[-2].number;
				yyPCB->Zoom = yyvsp[-1].floating;
			}
    break;

  case 30:
#line 262 "parse_y.y"
    {
				yyPCB->ThermScale = yyvsp[-1].floating;
			}
    break;

  case 31:
#line 269 "parse_y.y"
    {
				yyPCB->Flags = yyvsp[-1].number & PCB_FLAGS;
			}
    break;

  case 33:
#line 277 "parse_y.y"
    {
				if (ParseGroupString(yyvsp[-1].string, &yyPCB->LayerGroups))
				{
					Message("illegal layer-group string\n");
					YYABORT;
				}
			}
    break;

  case 35:
#line 288 "parse_y.y"
    {
				if (ParseRouteString(yyvsp[-1].string, &yyPCB->RouteStyle[0], 100))
				{
					Message("illegal route-style string\n");
					YYABORT;
				}
			}
    break;

  case 36:
#line 296 "parse_y.y"
    {
				if (ParseRouteString(yyvsp[-1].string, &yyPCB->RouteStyle[0], 1))
				{
					Message("illegal route-style string\n");
					YYABORT;
				}
			}
    break;

  case 46:
#line 322 "parse_y.y"
    {
					/* clear pointer to force memory allocation by 
					 * the appropriate subroutine
					 */
				yyElement = NULL;
			}
    break;

  case 48:
#line 329 "parse_y.y"
    { YYABORT; }
    break;

  case 54:
#line 343 "parse_y.y"
    {
				CreateNewVia(yyData, yyvsp[-8].number, yyvsp[-7].number, yyvsp[-6].number, yyvsp[-5].number, yyvsp[-4].number, yyvsp[-3].number, yyvsp[-2].string,
					(yyvsp[-1].number & OBJ_FLAGS) | VIAFLAG);
				SaveFree(yyvsp[-2].string);
			}
    break;

  case 55:
#line 353 "parse_y.y"
    {
				CreateNewVia(yyData, yyvsp[-8].number*100, yyvsp[-7].number*100, yyvsp[-6].number*100, yyvsp[-5].number*100, yyvsp[-4].number*100, yyvsp[-3].number*100, yyvsp[-2].string,
					(yyvsp[-1].number & OBJ_FLAGS) | VIAFLAG);
				SaveFree(yyvsp[-2].string);
			}
    break;

  case 56:
#line 364 "parse_y.y"
    {
				CreateNewVia(yyData, yyvsp[-7].number*100, yyvsp[-6].number*100, yyvsp[-5].number*100, yyvsp[-4].number*100, (yyvsp[-5].number + yyvsp[-4].number)*100, yyvsp[-3].number*100, yyvsp[-2].string,
					(yyvsp[-1].number & OBJ_FLAGS) | VIAFLAG);
				SaveFree(yyvsp[-2].string);
			}
    break;

  case 57:
#line 374 "parse_y.y"
    {
				CreateNewVia(yyData, yyvsp[-6].number*100, yyvsp[-5].number*100, yyvsp[-4].number*100, 200*GROUNDPLANEFRAME,
					(yyvsp[-4].number + 2*MASKFRAME)*100,  yyvsp[-3].number*100, yyvsp[-2].string, (yyvsp[-1].number & OBJ_FLAGS) | VIAFLAG);
				SaveFree(yyvsp[-2].string);
			}
    break;

  case 58:
#line 384 "parse_y.y"
    {
				BDimension	hole = (yyvsp[-3].number *DEFAULT_DRILLINGHOLE);

					/* make sure that there's enough copper left */
				if (yyvsp[-3].number -hole < MIN_PINORVIACOPPER && 
					yyvsp[-3].number > MIN_PINORVIACOPPER)
					hole = yyvsp[-3].number -MIN_PINORVIACOPPER;

				CreateNewVia(yyData, yyvsp[-5].number*100, yyvsp[-4].number*100, yyvsp[-3].number*100, 200*GROUNDPLANEFRAME,
					(yyvsp[-3].number + 2*MASKFRAME)*100, hole, yyvsp[-2].string, (yyvsp[-1].number & OBJ_FLAGS) | VIAFLAG);
				SaveFree(yyvsp[-2].string);
			}
    break;

  case 59:
#line 400 "parse_y.y"
    {
				CreateNewRat(yyData, yyvsp[-7].number, yyvsp[-6].number, yyvsp[-4].number, yyvsp[-3].number, yyvsp[-5].number, yyvsp[-2].number,
					Settings.RatThickness, (yyvsp[-1].number & OBJ_FLAGS));
			}
    break;

  case 60:
#line 405 "parse_y.y"
    {
				CreateNewRat(yyData, yyvsp[-7].number*100, yyvsp[-6].number*100, yyvsp[-4].number*100, yyvsp[-3].number*100, yyvsp[-5].number, yyvsp[-2].number,
					Settings.RatThickness, (yyvsp[-1].number & OBJ_FLAGS));
			}
    break;

  case 61:
#line 414 "parse_y.y"
    {
				if (yyvsp[-3].number <= 0 || yyvsp[-3].number > MAX_LAYER + 2)
				{
					yyerror("Layernumber out of range");
					YYABORT;
				}
				if (LayerFlag[yyvsp[-3].number-1])
				{
					yyerror("Layernumber used twice");
					YYABORT;
				}
				Layer = &yyData->Layer[yyvsp[-3].number-1];

					/* memory for name is alread allocated */
				Layer->Name = yyvsp[-2].string;
				LayerFlag[yyvsp[-3].number-1] = True;
			}
    break;

  case 73:
#line 453 "parse_y.y"
    {
				CreateNewPolygonFromRectangle(Layer,
					yyvsp[-5].number*100, yyvsp[-4].number*100, (yyvsp[-5].number+yyvsp[-3].number)*100, (yyvsp[-4].number+yyvsp[-2].number)*100, yyvsp[-1].number & OBJ_FLAGS);
			}
    break;

  case 77:
#line 462 "parse_y.y"
    {
				Polygon = CreateNewPolygon(Layer, yyvsp[-2].number & OBJ_FLAGS);
			}
    break;

  case 78:
#line 466 "parse_y.y"
    {
					/* ignore junk */
				if (Polygon->PointN >= 3)
					SetPolygonBoundingBox(Polygon);
				else
				{
					Message("WARNING parsing file '%s'\n"
						"    line:        %i\n"
						"    description: 'ignored polygon (< 3 points)'\n",
						yyfilename, yylineno);
					DestroyObject(PCB->Data, POLYGON_TYPE, Layer, Polygon, Polygon);
				}
			}
    break;

  case 79:
#line 484 "parse_y.y"
    {
				CreateNewLineOnLayer(Layer, yyvsp[-7].number, yyvsp[-6].number, yyvsp[-5].number, yyvsp[-4].number, yyvsp[-3].number, yyvsp[-2].number, yyvsp[-1].number & OBJ_FLAGS);
			}
    break;

  case 80:
#line 492 "parse_y.y"
    {
				CreateNewLineOnLayer(Layer, yyvsp[-7].number*100, yyvsp[-6].number*100, yyvsp[-5].number*100, yyvsp[-4].number*100, yyvsp[-3].number*100, yyvsp[-2].number*100, yyvsp[-1].number & OBJ_FLAGS);
			}
    break;

  case 81:
#line 500 "parse_y.y"
    {
				/* elliminate old-style rat-lines */
			if ((yyvsp[-1].number & RATFLAG) == 0)
				CreateNewLineOnLayer(Layer, yyvsp[-6].number*100, yyvsp[-5].number*100, yyvsp[-4].number*100, yyvsp[-3].number*100, yyvsp[-2].number*100,
					200*GROUNDPLANEFRAME, yyvsp[-1].number & OBJ_FLAGS);
			}
    break;

  case 82:
#line 511 "parse_y.y"
    {
				CreateNewArcOnLayer(Layer, yyvsp[-9].number, yyvsp[-8].number, yyvsp[-7].number, yyvsp[-3].number, yyvsp[-2].number, yyvsp[-5].number, yyvsp[-4].number, yyvsp[-1].number & OBJ_FLAGS);
			}
    break;

  case 83:
#line 519 "parse_y.y"
    {
				CreateNewArcOnLayer(Layer, yyvsp[-9].number*100, yyvsp[-8].number*100, yyvsp[-7].number*100, yyvsp[-3].number, yyvsp[-2].number, yyvsp[-5].number*100, yyvsp[-4].number*100, yyvsp[-1].number & OBJ_FLAGS);
			}
    break;

  case 84:
#line 527 "parse_y.y"
    {
				CreateNewArcOnLayer(Layer, yyvsp[-8].number*100, yyvsp[-7].number*100, yyvsp[-6].number*100, yyvsp[-3].number, yyvsp[-2].number,
					yyvsp[-4].number*100, 200*GROUNDPLANEFRAME, yyvsp[-1].number & OBJ_FLAGS);
			}
    break;

  case 85:
#line 536 "parse_y.y"
    {
					/* use a default scale of 100% */
				CreateNewText(Layer,yyFont,yyvsp[-5].number*100, yyvsp[-4].number*100, yyvsp[-3].number, 100, yyvsp[-2].string, yyvsp[-1].number & OBJ_FLAGS);
				SaveFree(yyvsp[-2].string);
			}
    break;

  case 86:
#line 546 "parse_y.y"
    {
				if (yyvsp[-1].number & ONSILKFLAG)
				{
					LayerTypePtr lay = &yyData->Layer[MAX_LAYER +
						((yyvsp[-1].number & ONSOLDERFLAG) ? SOLDER_LAYER : COMPONENT_LAYER)];

					CreateNewText(lay ,yyFont, yyvsp[-6].number*100, yyvsp[-5].number*100, yyvsp[-4].number, yyvsp[-3].number, yyvsp[-2].string, yyvsp[-1].number & OBJ_FLAGS);
				}
				else
					CreateNewText(Layer, yyFont, yyvsp[-6].number*100, yyvsp[-5].number*100, yyvsp[-4].number, yyvsp[-3].number, yyvsp[-2].string, yyvsp[-1].number & OBJ_FLAGS);
				SaveFree(yyvsp[-2].string);
			}
    break;

  case 87:
#line 562 "parse_y.y"
    {
				if (yyvsp[-1].number & ONSILKFLAG)
				{
					LayerTypePtr lay = &yyData->Layer[MAX_LAYER +
						((yyvsp[-1].number & ONSOLDERFLAG) ? SOLDER_LAYER : COMPONENT_LAYER)];

					CreateNewText(lay ,yyFont, yyvsp[-6].number, yyvsp[-5].number, yyvsp[-4].number, yyvsp[-3].number, yyvsp[-2].string, yyvsp[-1].number & OBJ_FLAGS);
				}
				else
					CreateNewText(Layer, yyFont, yyvsp[-6].number, yyvsp[-5].number, yyvsp[-4].number, yyvsp[-3].number, yyvsp[-2].string, yyvsp[-1].number & OBJ_FLAGS);
				SaveFree(yyvsp[-2].string);
			}
    break;

  case 90:
#line 584 "parse_y.y"
    {
				CreateNewPointInPolygon(Polygon, yyvsp[-2].number*100, yyvsp[-1].number*100);
			}
    break;

  case 91:
#line 588 "parse_y.y"
    {
				CreateNewPointInPolygon(Polygon, yyvsp[-2].number, yyvsp[-1].number);
			}
    break;

  case 98:
#line 607 "parse_y.y"
    {
				yyElement = CreateNewElement(yyData, yyElement, yyFont, 0x0000,
					yyvsp[-6].string, yyvsp[-5].string, NULL, yyvsp[-4].number*100, yyvsp[-3].number*100, yyvsp[-2].number, 100, 0x0000, False);
				SaveFree(yyvsp[-6].string);
				SaveFree(yyvsp[-5].string);
				pin_num = 1;
			}
    break;

  case 99:
#line 615 "parse_y.y"
    {
				SetElementBoundingBox(yyElement, yyFont);
			}
    break;

  case 100:
#line 625 "parse_y.y"
    {
				yyElement = CreateNewElement(yyData, yyElement, yyFont, yyvsp[-9].number,
					yyvsp[-8].string, yyvsp[-7].string, NULL, yyvsp[-6].number*100, yyvsp[-5].number*100, yyvsp[-4].number, yyvsp[-3].number, yyvsp[-2].number, False);
				SaveFree(yyvsp[-8].string);
				SaveFree(yyvsp[-7].string);
				pin_num = 1;
			}
    break;

  case 101:
#line 633 "parse_y.y"
    {
				SetElementBoundingBox(yyElement, yyFont);
			}
    break;

  case 102:
#line 643 "parse_y.y"
    {
				yyElement = CreateNewElement(yyData, yyElement, yyFont, yyvsp[-10].number,
					yyvsp[-9].string, yyvsp[-8].string, yyvsp[-7].string, yyvsp[-6].number*100, yyvsp[-5].number*100, yyvsp[-4].number, yyvsp[-3].number, yyvsp[-2].number, False);
				SaveFree(yyvsp[-9].string);
				SaveFree(yyvsp[-8].string);
				SaveFree(yyvsp[-7].string);
				pin_num = 1;
			}
    break;

  case 103:
#line 652 "parse_y.y"
    {
				SetElementBoundingBox(yyElement, yyFont);
			}
    break;

  case 104:
#line 663 "parse_y.y"
    {
				yyElement = CreateNewElement(yyData, yyElement, yyFont, yyvsp[-12].number,
					yyvsp[-11].string, yyvsp[-10].string, yyvsp[-9].string, (yyvsp[-8].number+yyvsp[-6].number)*100, (yyvsp[-7].number+yyvsp[-5].number)*100, yyvsp[-4].number, yyvsp[-3].number, yyvsp[-2].number, False);
				yyElement->MarkX = yyvsp[-8].number*100;
				yyElement->MarkY = yyvsp[-7].number*100;
				SaveFree(yyvsp[-11].string);
				SaveFree(yyvsp[-10].string);
				SaveFree(yyvsp[-9].string);
			}
    break;

  case 105:
#line 673 "parse_y.y"
    {
				SetElementBoundingBox(yyElement, yyFont);
			}
    break;

  case 106:
#line 684 "parse_y.y"
    {
				yyElement = CreateNewElement(yyData, yyElement, yyFont, yyvsp[-12].number,
					yyvsp[-11].string, yyvsp[-10].string, yyvsp[-9].string, (yyvsp[-8].number+yyvsp[-6].number), (yyvsp[-7].number+yyvsp[-5].number), yyvsp[-4].number, yyvsp[-3].number, yyvsp[-2].number, False);
				yyElement->MarkX = yyvsp[-8].number;
				yyElement->MarkY = yyvsp[-7].number;
				SaveFree(yyvsp[-11].string);
				SaveFree(yyvsp[-10].string);
				SaveFree(yyvsp[-9].string);
			}
    break;

  case 107:
#line 694 "parse_y.y"
    {
				SetElementBoundingBox(yyElement, yyFont);
			}
    break;

  case 115:
#line 712 "parse_y.y"
    {
				CreateNewLineInElement(yyElement, yyvsp[-5].number, yyvsp[-4].number, yyvsp[-3].number, yyvsp[-2].number, yyvsp[-1].number);
			}
    break;

  case 116:
#line 717 "parse_y.y"
    {
				CreateNewLineInElement(yyElement, yyvsp[-5].number*100, yyvsp[-4].number*100, yyvsp[-3].number*100, yyvsp[-2].number*100, yyvsp[-1].number*100);
			}
    break;

  case 117:
#line 722 "parse_y.y"
    {
				CreateNewArcInElement(yyElement, yyvsp[-7].number, yyvsp[-6].number, yyvsp[-5].number, yyvsp[-4].number, yyvsp[-3].number, yyvsp[-2].number, yyvsp[-1].number);
			}
    break;

  case 118:
#line 726 "parse_y.y"
    {
				CreateNewArcInElement(yyElement, yyvsp[-7].number*100, yyvsp[-6].number*100, yyvsp[-5].number*100, yyvsp[-4].number*100, yyvsp[-3].number, yyvsp[-2].number, yyvsp[-1].number*100);
			}
    break;

  case 119:
#line 731 "parse_y.y"
    {
				yyElement->MarkX = yyvsp[-2].number;
				yyElement->MarkY = yyvsp[-1].number;
			}
    break;

  case 120:
#line 736 "parse_y.y"
    {
				yyElement->MarkX = yyvsp[-2].number*100;
				yyElement->MarkY = yyvsp[-1].number*100;
			}
    break;

  case 127:
#line 754 "parse_y.y"
    {
				CreateNewLineInElement(yyElement, yyvsp[-5].number + yyElement->MarkX,
					yyvsp[-4].number + yyElement->MarkY, yyvsp[-3].number + yyElement->MarkX,
					yyvsp[-2].number + yyElement->MarkY, yyvsp[-1].number);
			}
    break;

  case 128:
#line 760 "parse_y.y"
    {
				CreateNewLineInElement(yyElement, yyvsp[-5].number*100 + yyElement->MarkX,
					yyvsp[-4].number*100 + yyElement->MarkY, yyvsp[-3].number*100 + yyElement->MarkX,
					yyvsp[-2].number*100 + yyElement->MarkY, yyvsp[-1].number*100);
			}
    break;

  case 129:
#line 767 "parse_y.y"
    {
				CreateNewArcInElement(yyElement, yyvsp[-7].number + yyElement->MarkX,
					yyvsp[-6].number + yyElement->MarkY, yyvsp[-5].number, yyvsp[-4].number, yyvsp[-3].number, yyvsp[-2].number, yyvsp[-1].number);
			}
    break;

  case 130:
#line 772 "parse_y.y"
    {
				CreateNewArcInElement(yyElement, yyvsp[-7].number*100 + yyElement->MarkX,
					yyvsp[-6].number*100 + yyElement->MarkY, yyvsp[-5].number*100, yyvsp[-4].number*100, yyvsp[-3].number, yyvsp[-2].number, yyvsp[-1].number*100);
			}
    break;

  case 131:
#line 782 "parse_y.y"
    {
				CreateNewPin(yyElement, yyvsp[-9].number + yyElement->MarkX,
					yyvsp[-8].number + yyElement->MarkY, yyvsp[-7].number, yyvsp[-6].number, yyvsp[-5].number, yyvsp[-4].number, yyvsp[-3].string,
					yyvsp[-2].string, (yyvsp[-1].number & OBJ_FLAGS) | PINFLAG);
				SaveFree(yyvsp[-3].string);
				SaveFree(yyvsp[-2].string);
			}
    break;

  case 132:
#line 794 "parse_y.y"
    {
				CreateNewPin(yyElement, yyvsp[-9].number*100 + yyElement->MarkX,
					yyvsp[-8].number*100 + yyElement->MarkY, yyvsp[-7].number*100, yyvsp[-6].number*100, yyvsp[-5].number*100, yyvsp[-4].number*100, yyvsp[-3].string,
					yyvsp[-2].string, (yyvsp[-1].number & OBJ_FLAGS) | PINFLAG);
				SaveFree(yyvsp[-3].string);
				SaveFree(yyvsp[-2].string);
			}
    break;

  case 133:
#line 806 "parse_y.y"
    {
				CreateNewPin(yyElement, yyvsp[-7].number*100, yyvsp[-6].number*100, yyvsp[-5].number*100, 200*GROUNDPLANEFRAME,
					(yyvsp[-5].number + 2*MASKFRAME)*100, yyvsp[-4].number*100, yyvsp[-3].string, yyvsp[-2].string,
					(yyvsp[-1].number & OBJ_FLAGS) | PINFLAG);
				SaveFree(yyvsp[-3].string);
				SaveFree(yyvsp[-2].string);
			}
    break;

  case 134:
#line 818 "parse_y.y"
    {
				char	p_number[8];

				sprintf(p_number, "%d", pin_num++);
				CreateNewPin(yyElement, yyvsp[-6].number*100, yyvsp[-5].number*100, yyvsp[-4].number*100, 200*GROUNDPLANEFRAME,
					(yyvsp[-4].number + 2*MASKFRAME)*100, yyvsp[-3].number*100, yyvsp[-2].string, p_number,
					(yyvsp[-1].number & OBJ_FLAGS) | PINFLAG);
				SaveFree(yyvsp[-2].string);
			}
    break;

  case 135:
#line 834 "parse_y.y"
    {
				BDimension	hole = (yyvsp[-3].number *DEFAULT_DRILLINGHOLE);
				char		p_number[8];

					/* make sure that there's enough copper left */
				if (yyvsp[-3].number -hole < MIN_PINORVIACOPPER && 
					yyvsp[-3].number > MIN_PINORVIACOPPER)
					hole = yyvsp[-3].number -MIN_PINORVIACOPPER;

				sprintf(p_number, "%d", pin_num++);
				CreateNewPin(yyElement, yyvsp[-5].number*100, yyvsp[-4].number*100, yyvsp[-3].number*100, 200*GROUNDPLANEFRAME,
					(yyvsp[-3].number + 2*MASKFRAME)*100, hole, yyvsp[-2].string, p_number,
					(yyvsp[-1].number & OBJ_FLAGS) | PINFLAG);
				SaveFree(yyvsp[-2].string);
			}
    break;

  case 136:
#line 854 "parse_y.y"
    {
				CreateNewPad(yyElement,yyvsp[-10].number + yyElement->MarkX,
					yyvsp[-9].number + yyElement->MarkY, yyvsp[-8].number + yyElement->MarkX,
					yyvsp[-7].number + yyElement->MarkY, yyvsp[-6].number, yyvsp[-5].number, yyvsp[-4].number,
					yyvsp[-3].string, yyvsp[-2].string, (yyvsp[-1].number & OBJ_FLAGS));
				SaveFree(yyvsp[-3].string);
				SaveFree(yyvsp[-2].string);
			}
    break;

  case 137:
#line 867 "parse_y.y"
    {
				CreateNewPad(yyElement,yyvsp[-10].number*100 + yyElement->MarkX,
					yyvsp[-9].number*100 + yyElement->MarkY, yyvsp[-8].number*100 + yyElement->MarkX,
					yyvsp[-7].number*100 + yyElement->MarkY, yyvsp[-6].number*100, yyvsp[-5].number*100, yyvsp[-4].number*100,
					yyvsp[-3].string, yyvsp[-2].string, (yyvsp[-1].number & OBJ_FLAGS));
				SaveFree(yyvsp[-3].string);
				SaveFree(yyvsp[-2].string);
			}
    break;

  case 138:
#line 880 "parse_y.y"
    {
				CreateNewPad(yyElement,yyvsp[-8].number*100,yyvsp[-7].number*100,yyvsp[-6].number*100,yyvsp[-5].number*100,yyvsp[-4].number*100, 200*GROUNDPLANEFRAME,
					(yyvsp[-4].number + 2*MASKFRAME)*100, yyvsp[-3].string,yyvsp[-2].string, (yyvsp[-1].number & OBJ_FLAGS));
				SaveFree(yyvsp[-3].string);
				SaveFree(yyvsp[-2].string);
			}
    break;

  case 139:
#line 891 "parse_y.y"
    {
				char		p_number[8];

				sprintf(p_number, "%d", pin_num++);
				CreateNewPad(yyElement,yyvsp[-7].number*100,yyvsp[-6].number*100,yyvsp[-5].number*100,yyvsp[-4].number*100,yyvsp[-3].number*100, 200*GROUNDPLANEFRAME,
					(yyvsp[-3].number + 2*MASKFRAME)*100, yyvsp[-2].string,p_number,
					(yyvsp[-1].number & OBJ_FLAGS));
				SaveFree(yyvsp[-2].string);
			}
    break;

  case 142:
#line 909 "parse_y.y"
    {
				if (yyvsp[-3].number <= 0 || yyvsp[-3].number > MAX_FONTPOSITION)
				{
					yyerror("fontposition out of range");
					YYABORT;
				}
				Symbol = &yyFont->Symbol[yyvsp[-3].number];
				if (Symbol->Valid)
				{
					yyerror("symbol ID used twice");
					YYABORT;
				}
				Symbol->Valid = True;
				Symbol->Delta = yyvsp[-2].number;
			}
    break;

  case 144:
#line 926 "parse_y.y"
    {
				if (yyvsp[-3].number <= 0 || yyvsp[-3].number > MAX_FONTPOSITION)
				{
					yyerror("fontposition out of range");
					YYABORT;
				}
				Symbol = &yyFont->Symbol[yyvsp[-3].number];
				if (Symbol->Valid)
				{
					yyerror("symbol ID used twice");
					YYABORT;
				}
				Symbol->Valid = True;
				Symbol->Delta = yyvsp[-2].number*100;
			}
    break;

  case 153:
#line 963 "parse_y.y"
    {
				CreateNewLineInSymbol(Symbol, yyvsp[-5].number*100, yyvsp[-4].number*100, yyvsp[-3].number*100, yyvsp[-2].number*100, yyvsp[-1].number*100);
			}
    break;

  case 154:
#line 970 "parse_y.y"
    {
				CreateNewLineInSymbol(Symbol, yyvsp[-5].number, yyvsp[-4].number, yyvsp[-3].number, yyvsp[-2].number, yyvsp[-1].number);
			}
    break;

  case 162:
#line 997 "parse_y.y"
    {
				Menu = CreateNewNet(&yyPCB->NetlistLib, yyvsp[-3].string, yyvsp[-2].string);
				SaveFree(yyvsp[-3].string);
				SaveFree(yyvsp[-2].string);
			}
    break;

  case 168:
#line 1017 "parse_y.y"
    {
				CreateNewConnection(Menu, yyvsp[-1].string);
				SaveFree(yyvsp[-1].string);
			}
    break;


    }

/* Line 991 of yacc.c.  */
#line 2356 "parse_y.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("syntax error, unexpected ") + 1;
	  yysize += yystrlen (yytname[yytype]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* Return failure if at end of input.  */
      if (yychar == YYEOF)
        {
	  /* Pop the error token.  */
          YYPOPSTACK;
	  /* Pop the rest of the stack.  */
	  while (yyss < yyssp)
	    {
	      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
	      yydestruct (yystos[*yyssp], yyvsp);
	      YYPOPSTACK;
	    }
	  YYABORT;
        }

      YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
      yydestruct (yytoken, &yylval);
      yychar = YYEMPTY;

    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab2;


/*----------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action.  |
`----------------------------------------------------*/
yyerrlab1:

  /* Suppress GCC warning that yyerrlab1 is unused when no action
     invokes YYERROR.  MacOS 10.2.3's buggy "smart preprocessor"
     insists on the trailing semicolon.  */
#if defined (__GNUC_MINOR__) && 2093 <= (__GNUC__ * 1000 + __GNUC_MINOR__)
  __attribute__ ((__unused__));
#endif


  goto yyerrlab2;


/*---------------------------------------------------------------.
| yyerrlab2 -- pop states until the error token can be shifted.  |
`---------------------------------------------------------------*/
yyerrlab2:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      yyvsp--;
      yystate = *--yyssp;

      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 83 "parse_y.y"


/* ---------------------------------------------------------------------------
 * error routine called by parser library
 */
int yyerror(s)
char *s;
{
	Message("ERROR parsing file '%s'\n"
		"    line:        %i\n"
		"    description: '%s'\n",
		yyfilename, yylineno, s);
	return(0);
}


